#import "Controller.h"

@implementation Controller
-(void)awakeFromNib{

    toolbarItems=[[NSMutableDictionary alloc] init];
    [self addToolbarItemToDictionary:toolbarItems label:@"New" paletteLabel:@"New" target:self action:@selector(new:) toolTip:@"Add new entry or attribute" identifier:@"new" image:[NSImage imageNamed:@"newFolder.tiff"]];
    [self addToolbarItemToDictionary:toolbarItems label:@"Delete Item" paletteLabel:@"Delete Item" target:self action:@selector(deleteEntry:) toolTip:@"Delete entry at current position" identifier:@"deleteEntry" image:[NSImage imageNamed:@"deleteIcon.tiff"]];
    [self addToolbarItemToDictionary:toolbarItems label:@"Duplicate Item" paletteLabel:@"Duplicate Item" target:self action:@selector(duplicateEntry:) toolTip:@"Duplicate Item at current position" identifier:@"duplicateEntry" image:[NSImage imageNamed:@"duplicateFolder.tiff"]];
    NSToolbar *tb=[[[NSToolbar alloc] initWithIdentifier:@"mainToolbar"] autorelease];
    [tb setDelegate:self];
    [tb setAllowsUserCustomization:YES];
    [tb setAutosavesConfiguration: YES];
    [mainWindow setToolbar:tb];
	[entryBrowserView setPathSeparator:@"/////"];
    

}
-addToolbarItemToDictionary:(NSMutableDictionary *)dict label:(NSString *)label paletteLabel:(NSString *)pl target:(id)target action:(SEL)action toolTip:(NSString *)toolTip identifier:(NSString *)identifier image:(NSImage *)image{
    
    NSToolbarItem *tbi=[[[NSToolbarItem alloc] initWithItemIdentifier:identifier] autorelease];
    [tbi setLabel:label];
    [tbi setPaletteLabel:pl];
    [tbi setTarget:target];
    [tbi setToolTip:toolTip];
    [tbi setAction:action];
    [tbi performSelector:@selector(setImage:) withObject:image];
    [dict setObject:tbi forKey:identifier];
    
    return dict;
}
- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar *)toolbar{
     return [NSArray arrayWithObjects: 
        @"new",@"duplicateEntry",@"deleteEntry",NSToolbarPrintItemIdentifier,
	 NSToolbarCustomizeToolbarItemIdentifier,
        NSToolbarFlexibleSpaceItemIdentifier,
        NSToolbarSpaceItemIdentifier,
        NSToolbarSeparatorItemIdentifier, nil];
    
}

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)itemIdentifier willBeInsertedIntoToolbar:(BOOL)flag{
    NSToolbarItem *newItem=[[[toolbarItems objectForKey:itemIdentifier] copy] autorelease];
    return newItem;
}
    

    //[toolbarItems objectForKey:NSToolbarPrintItemIdentifier];

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar{

    return [NSArray arrayWithObjects: 
        @"new",@"duplicateEntry",@"deleteEntry",NSToolbarPrintItemIdentifier,
	NSToolbarCustomizeToolbarItemIdentifier,
        NSToolbarFlexibleSpaceItemIdentifier,
        NSToolbarSpaceItemIdentifier, nil];
    
    
}


- (IBAction)connect:(id)sender
{
    switch ([[authPopUpButton selectedItem] tag]) {
	case 1:
	    ldap=[[LDAPQuery alloc] initWithHostURL:[hostTextField stringValue] port:[portTextField intValue] authType:AUTH_SIMPLE bindUsername:[usernameTextfield stringValue] bindPassword:[passwordTextfield stringValue] dn:[baseDNTextField stringValue] saslUsername:nil];
	    break;
	case 2:
	    ldap=[[LDAPQuery alloc] initWithHostURL:[hostTextField stringValue] port:[portTextField intValue] authType:AUTH_MD5 bindUsername:[usernameTextfield stringValue] bindPassword:[passwordTextfield stringValue] dn:[baseDNTextField stringValue] saslUsername:[saslUserNameTextfield stringValue]];
	    break;
	default:
	    ldap=[[LDAPQuery alloc] initWithHostURL:[hostTextField stringValue] port:[portTextField intValue] authType:AUTH_ANONYMOUS bindUsername:nil bindPassword:nil dn:[baseDNTextField stringValue] saslUsername:nil];
	    break;
    }
    if ([ldap bound]){
	[[entryBrowserView delegate] setLDAP:ldap];
	[browserWindow makeKeyAndOrderFront:self];
	[connectWindow close];
	[[entryBrowserView delegate] setBaseDN:[baseDNTextField stringValue]];
	[entryBrowserView loadColumnZero];
	// added by smb 4/11
	// this will add a title to the window reflect the ldap server and base dc
	// we can add to this to reflect ssl or customer port when we get a chance	
	[mainWindow setTitle:[NSString stringWithFormat:@"ldap://%@/%@", [hostTextField stringValue], [baseDNTextField stringValue]]];
    }	
    else {
	NSRunAlertPanel(@"Error!", [ldap lastError], @"OK", nil, nil);
	[ldap release];
    }
    


}

- (IBAction)deleteAttribute:(id)sender
{
}

- (IBAction)deleteEntry:(id)sender
{
  
    if ([attributeOutlineView selectedRow]!=-1){
	NSLog(@"delete attribute %i",[attributeOutlineView selectedRow]);
    }
    else {
	NSLog(@"delete entry");
    }

}

- (IBAction)insertAttribute:(id)sender
{
}


- (IBAction)new:(id)sender
{
    NSLog(@"new");
}

- (IBAction)duplicateEntry:(id)sender
{
    NSLog(@"duplicateEntry");
}


- (IBAction)revert:(id)sender
{
}

- (IBAction)save:(id)sender
{
}
- (IBAction)fetchDNButton:(id)sender{
	Attribute *temp;
    ldap=[[LDAPQuery alloc] initWithHostURL:[hostTextField stringValue] port:[portTextField intValue] authType:AUTH_ANONYMOUS bindUsername:nil bindPassword:nil dn:@"" saslUsername:nil];
	temp = [[[ldap searchWithFilter:@"(objectclass=*)" forAttributes:[NSArray arrayWithObject:@"namingContexts"] scope:LDAP_SCOPE_BASE searchDN:@""] childAtIndex:0] childAtIndex:0];
	[baseDNTextField setStringValue:[temp itemName]];
    [ldap release];
    
}

- (IBAction)authMethodChanged:(id)sender{

    switch ([[sender selectedItem] tag]) {
	case 1: [saslUserNameTextfield setEnabled:NO];
	    [passwordTextfield setEnabled:YES];
	    [usernameTextfield setEnabled:YES];

	    break;
	case 2:[saslUserNameTextfield setEnabled:YES];
	    [passwordTextfield setEnabled:YES];
	    [usernameTextfield setEnabled:YES];
	    break;
	default: [saslUserNameTextfield setEnabled:NO];
	    [passwordTextfield setEnabled:NO];
	    [usernameTextfield setEnabled:NO];
	    break;
    }
}
-(void)dealloc{
    [ldap release];
    [super dealloc];
}
@end
