//#import <Foundation/Foundation.h>
#import "CustomColumn.h"

@implementation CustomColumn

- (id)multiLineCell
{
	if(!MultiLineCell)
	{
		MultiLineCell = [[NSButtonCell alloc] init];
		[MultiLineCell setTitle:@"<multiline value>"];
		[MultiLineCell setEditable:NO];
		[MultiLineCell setControlSize:NSMiniControlSize];
		[MultiLineCell setImagePosition:NSImageLeft];
		[MultiLineCell setAlignment:NSLeftTextAlignment];
		[MultiLineCell setHighlightsBy:NSNoCellMask];
		[MultiLineCell setBezeled:NO];
		[MultiLineCell setBordered:NO];
		[MultiLineCell setTarget:[[self tableView] dataSource]];
		[MultiLineCell setAction:@selector(openSheetForMultiLineAttribute:)];	  
		[MultiLineCell setImage:[NSImage imageNamed:@"MultiLine.tiff"]];
		}
		return MultiLineCell;
}

- (void)dealloc
{
	if(MultiLineCell) {
		[MultiLineCell release];
	}
	[super dealloc];
}

- (id)dataCellForRow:(int)row
{
   	id outlineView = [self tableView];
	id item = [outlineView itemAtRow:row];
	id datasource = [outlineView dataSource];
	int cellType = [datasource outlineView:outlineView cellTypeForItem:item];
	if(cellType == 0) return [self dataCell];
	if(cellType == 1) return [self multiLineCell];
	return [self dataCell];
}

@end
