/* DataSource */

#import <Cocoa/Cocoa.h>
#import "LDAPQuery.h"
#import "Browser.h"
#import "Matrix.h"

@interface DataSource : NSObject
{
    NSMutableDictionary *entries;
    NSMutableArray *outlineViewCache;
    NSString *baseDN;
    LDAPQuery *ldap;
    BOOL dataAvailable,searchRunning;

    IBOutlet id dnTextField;    
    IBOutlet id myWindow;    
    IBOutlet id entryBrowserView;
    IBOutlet id attributeOutlineView;    

    IBOutlet id myEditPanel;
    IBOutlet id editPanelTextField;
    IBOutlet id editPanelTextView;
    NSSize attSize, valSize;
}
//-(void)docModifiedSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
-(void)refresh;
//-(void)deleteEntryAtPath:(NSArray *)val;
//- (int)browser:(Browser *)sender numberOfRowsInColumn:(int)column;
- (IBAction)browserViewSelectionDidChange:(id)sender;
-(void)setBaseDN:(NSString *)newBaseDN;
//-(void)addEntry:(Entry *)newEntry;
-(void)setLDAP:(LDAPQuery *)newLDAP;
//-(NSArray *)transposePath:(NSArray *)oldPath;
//-(id)objectForPath:(NSArray *)path;
//-(void)deleteEntryAtPath:(NSString *)val;
//-(LDAPAttribute *)currentAttributes;
- (int)outlineView:(NSOutlineView*)outlineView cellTypeForItem:(id)item;

// EditPanel Stuff
- (IBAction)openSheetForMultiLineAttribute:(id)sender;
- (IBAction)closeEditWindow:(id)sender;
- (BOOL)isMultilined:(NSString *)val;
@end
