#import "DataSource.h"
#define MAXVALLENGTH 25
@implementation DataSource

#pragma mark Startup Methods
-(void)awakeFromNib{
    dataAvailable=NO;
    [entryBrowserView setMatrixClass:NSClassFromString(@"Matrix")];
    outlineViewCache=[[NSMutableArray alloc] init];
}

/*- (BOOL)selectionShouldChangeInTableView:(NSTableView *)aTableView{
    if ([[aTableView window] isDocumentEdited]) return NO;
    else return YES;
}
*/
#pragma mark Browser Methods
- (IBAction)browserViewSelectionDidChange:(id)sender{
    [outlineViewCache removeAllObjects];
    [dnTextField setStringValue:[[entryBrowserView pathArray] description]];

    if (![myWindow isDocumentEdited]) {

	
	NSMutableDictionary *parent = [entries objectForKey:[[entryBrowserView pathArray] componentsJoinedByString:@","]];
    	if (![parent objectForKey:@"attributes"]) {
	  //  NSLog(@"attraibuts not found...seraching fo rthem");
	    [ldap searchWithFilter:@"(objectClass=*)" forAttributes:nil scope:LDAP_SCOPE_BASE searchDN:[entryBrowserView currentDN] target:self selector:@selector(addAttributes:)];
	}
    }
    [attributeOutlineView reloadData];
}
- (BOOL)browser:(NSBrowser *)sender isColumnValid:(int)column{
    return YES;
}
#pragma mark Modified Document Methods
- (IBAction)closeEditWindow:(id)sender
{
    [NSApp endSheet:myEditPanel];
}

/*- (void)textDidChange:(NSNotification *)aNotification{
    [myWindow setDocumentEdited:YES];
}

- (void)controlTextDidChange:(NSNotification *)aNotification{
    [[[aNotification object] window] setDocumentEdited:YES];
}
*/
-(void)docModifiedSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo{

    switch (returnCode) {
	case  0:  //revert
	   // [mainWindow setDocumentEdited:NO];

	    break;
	case -1:  //cancel
	    break;
	case 1: // save
	    
//	    if([self commit]) {
		//[mainWindow setDocumentEdited:NO];
		//[mainWindow close];
//	    } 
		break;
    }
}

#pragma mark Update Datasource Methods
-(void)addEntries:(NSMutableDictionary *)newChildren{
    dataAvailable=YES;
    NSString *childDN=[newChildren objectForKey:@"dn"];
    NSArray *dnArray=[childDN componentsSeparatedByString:@","];
    NSString *newKey=[dnArray objectAtIndex:0];
    NSMutableArray *parentArray=[NSMutableArray arrayWithArray:dnArray];
    [parentArray removeObjectAtIndex:0];
    
    NSString *parentDN=[parentArray componentsJoinedByString:@","];
    NSMutableDictionary *parent=[entries objectForKey:parentDN];
    [entries setObject:newChildren forKey:childDN];
    
    if(![parent objectForKey:@"children"]) [parent setObject:[NSMutableDictionary dictionary] forKey:@"children"];
    [[parent objectForKey:@"children"] setObject:newChildren forKey:newKey];
    [parent setObject:[NSNumber numberWithBool:YES] forKey:@"isCached"];
   if ([entryBrowserView selectedColumn]<0) [entryBrowserView loadColumnZero];
   else [entryBrowserView reloadColumn:[entryBrowserView selectedColumn]+1];


}
-(void)addAttributes:(NSMutableDictionary *)newChildren{
    NSString *childDN=[newChildren objectForKey:@"dn"];
    NSMutableDictionary *child=[entries objectForKey:childDN];
    [child setObject:[newChildren objectForKey:@"attributes"] forKey:@"attributes"];
        [child setObject:[NSNumber numberWithBool:YES] forKey:@"isCached"];
   [attributeOutlineView reloadData];
}

	
- (void)browser:(NSBrowser *)sender createRowsForColumn:(int)column inMatrix:(NSMatrix *)matrix{
    NSDictionary *currEntryChildren;
    if (entries) {
	 if (column==0) {
	      [matrix addRow];
	      NSBrowserCell *cell=[matrix cellAtRow:column column:0];
	     [cell setStringValue:[entries objectForKey:@"dn"]];
	 }
	 else {
	     //if (!(currEntry=[[entries objectForKey:[entryBrowserView currentDN]] objectForKey:@"children"])) {  //check to see if we already have the data in array
	     if (![[entries objectForKey:[entryBrowserView currentDN]] objectForKey:@"isCached"]) {  //check to see if we already 
	     // [matrix addRow];
	     // NSBrowserCell *cell=[matrix cellAtRow:0 column:0];
		//[cell setStringValue:@"looking up..."];
		 //NSLog(@"dn not found...looking up");
		[[sender selectedCell] setLeaf:YES];
		[ldap searchWithFilter:@"(objectClass=*)" forAttributes:[NSArray arrayWithObject:@""] scope:LDAP_SCOPE_ONELEVEL searchDN:[entryBrowserView currentDN] target:self selector:@selector(addEntries:)];
		searchRunning=YES;
		[[entries objectForKey:[entryBrowserView currentDN]] setObject:[NSNumber numberWithBool:NO] forKey:@"isCached"];
	    }
	     else {
		 int i;
		 NSDictionary *currEntryParent;
		 currEntryParent=[entries objectForKey:[entryBrowserView currentDN]];
		 currEntryChildren=[currEntryParent objectForKey:@"children"];

		 if ([[currEntryParent objectForKey:@"isCached"] boolValue]==NO){
		     [[sender selectedCell] setLeaf:NO];

		 }
		 else {
		     if ([currEntryChildren count]>0){
			 [[sender selectedCell] setLeaf:NO];
		     }
		     else {
			 [[sender selectedCell] setLeaf:YES];
		     }
		 }


		 NSArray *keys=[[currEntryChildren allKeys] sortedArrayUsingSelector:@selector(caseInsensitiveCompare:)];
		 for (i=0;i<[keys count]; i++) {
		      [matrix addRow];
		      NSBrowserCell *cell=[matrix cellAtRow:i column:0];
		      NSDictionary *currEntryChild=[currEntryChildren objectForKey:[keys objectAtIndex:i]];
		      if ([[currEntryChild objectForKey:@"isCached"] boolValue]==NO) {
			  [cell setLeaf:NO];
		      }
		      else {
			  if ([[currEntryChild objectForKey:@"children"] count]>0){
			      [cell setLeaf:NO];
			  }
			  else {
			      [cell setLeaf:YES];
			  }
			  
		      }
		      [cell setStringValue:[keys objectAtIndex:i]];
		 }
	     
	     }
	 }
    }

    
}
#pragma mark Outline View Methods
// This method is called repeatedly when the table view is displaying it self. 
- (id)outlineView:(NSOutlineView *)ov child:(int)index ofItem:(id)item
{
    // is the parent non-nil?
    if (item) {


	NSString *myKey=[item objectForKey:@"entry"];
	id myObject=[[item objectForKey:@"value"] objectAtIndex:index];
	NSDictionary *newDict=[NSDictionary dictionaryWithObjectsAndKeys:myObject,@"value",myKey,@"entry",[NSNumber numberWithBool:NO],@"MV",nil];
	[outlineViewCache addObject:newDict];
	return newDict;
    } 
    else { 
	   NSMutableDictionary *parent=[entries objectForKey:[entryBrowserView currentDN]];
	if([parent objectForKey:@"attributes"]) {
	    BOOL mv;
	    NSMutableDictionary *dict=[parent objectForKey:@"attributes"];
	    NSArray *allKeys=[dict allKeys];
	    id myObject=[dict objectForKey:[allKeys objectAtIndex:index]];
	    NSString *multiprint=@"";
	    if ([myObject isKindOfClass:[NSArray class]]) {
		mv=YES;
		multiprint=[myObject description];
	    }
	    else mv=NO;
	    
	    NSDictionary *newDict=[NSDictionary dictionaryWithObjectsAndKeys:myObject,@"value",[allKeys objectAtIndex:index],@"entry",[NSNumber numberWithBool:mv],@"MV",multiprint,@"multiprint",nil];
	    [outlineViewCache addObject:newDict];
	    return newDict;
	}
    }
    return nil;

}

// Called repeatedly to find out if there should be an
// "expand triangle" next to the label
- (BOOL)outlineView:(NSOutlineView *)ov isItemExpandable:(id)item
{
    if ([[item objectForKey:@"MV"] boolValue]) return YES;
    else return NO;

}

// Called repeatedly when the table view is displaying itself
- (int)outlineView:(NSOutlineView *)ov numberOfChildrenOfItem:(id)item
{
    if (dataAvailable) {
	if (item == nil) {
	    NSMutableDictionary *parent=[entries objectForKey:[entryBrowserView currentDN]];
	    if([parent objectForKey:@"attributes"]) {
		return [[parent objectForKey:@"attributes"] count];
	    }
	    else {
		return 0;
	    }
	}
	else {
	    return [[item objectForKey:@"value"] count]; 
	}
    }
    return 0;

}

// This method gets called repeatedly when the outline view is trying
// to display itself.

- (id)outlineView:(NSOutlineView *)ov objectValueForTableColumn:(NSTableColumn *)aTableColumn byItem:(id)item
{
    if (dataAvailable) {

	switch ([[aTableColumn identifier] intValue]) {
	    case 0:
		return [item objectForKey:@"entry"];
		break;
	    case 1:
		if ([[item objectForKey:@"MV"] boolValue]) {
		    
		    int i;
		    NSArray *array=[item objectForKey:@"value"];
		    NSMutableArray *newArray=[NSMutableArray arrayWithArray:array];
		    for (i=0;i<[array count];i++) {
			if ([[newArray objectAtIndex:i] length] > MAXVALLENGTH) [newArray replaceObjectAtIndex:i withObject:[NSString stringWithFormat:@"%@...",[[newArray objectAtIndex:i] substringToIndex:MAXVALLENGTH-3]]];
		    }
		    return [NSString stringWithFormat:@"(%@)",[newArray componentsJoinedByString:@","]];
		}
		else return [item objectForKey:@"value"];		  
		break; 
	} // end switch
    }
    return nil;
}
- (int)outlineView:(NSOutlineView*)outlineView cellTypeForItem:(id)item
{
	if (dataAvailable) {
	    if ([[item objectForKey:@"MV"] boolValue]==NO) {
		if ([self isMultilined:[item objectForKey:@"value"]]) return 1;
		else return 0;
	    }
	}

	return 0;
}


/*-(void)addEntry:(Entry *)newEntry{
    [entries setObject:newEntry forKey:[newEntry rdn]]; 
}
*/


/*-(void)deleteEntryAtPath:(NSArray *)val{
    int column=[entryBrowserView selectedColumn];
    int row=[entryBrowserView selectedRowInColumn:column];
    Entry *objectToDelete=[self objectForPath:val inDict:entries];
    Entry *parent=[objectToDelete parent];
    Entry *child=[[parent children] objectForKey:[val objectAtIndex:0]];
    [child setLDAPAttributes:nil];
    [[parent children] removeObjectForKey:[val objectAtIndex:0]];
    [parent optimize];

    [entryBrowserView reloadColumn:column];
    [entryBrowserView selectRow:row inColumn:column];
        [self refreshAttributes];
    [attributeOutlineView reloadData];
    
    [self browserViewSelectionDidChange:nil];
}
*/
#pragma mark Refresh
-(void)refresh{
    NSMutableDictionary *currEntry;
    currEntry=[entries objectForKey:[entryBrowserView currentDN]];
    [currEntry removeObjectForKey:@"children"];
    [currEntry removeObjectForKey:@"isCached"];
    [attributeOutlineView deselectAll:self];
    [entryBrowserView reloadColumn:[entryBrowserView lastVisibleColumn]];
    [attributeOutlineView deselectAll:self];
    [attributeOutlineView reloadData];
    
}
#pragma mark Multiline
- (IBAction)openSheetForMultiLineAttribute:(id)sender
{
    [editPanelTextField setStringValue:[[sender itemAtRow:[sender selectedRow]] objectForKey:@"entry"]];
    [editPanelTextView setString:[[sender itemAtRow:[sender selectedRow]] objectForKey:@"value"]];
    [NSApp beginSheet:myEditPanel modalForWindow:myWindow modalDelegate:self didEndSelector:@selector(sheetDidEnd:returnCode:contextInfo:) contextInfo:nil];
}
-(void)sheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo{
    [sheet orderOut:self];
}
- (BOOL)isMultilined:(NSString *)val
{
    if([[val componentsSeparatedByString:@"\n"] count] > 1) {
	return YES;
    }
    return NO;
}
#pragma mark Accessor Methods
-(void)setBaseDN:(NSString *)newBaseDN{
    [newBaseDN retain];
    [baseDN release];
    baseDN=newBaseDN;
    [entries release];
    entries=[[NSMutableDictionary alloc] init];
    NSMutableDictionary *newDict=[NSMutableDictionary dictionary];
    //[newDict setObject:[NSMutableDictionary dictionary] forKey:@"children"];
    [entries setObject:newDict forKey:newBaseDN]; 
    [entries setObject:newBaseDN forKey:@"dn"];
    
}

-(void)setLDAP:(LDAPQuery *)newLDAP{
    [newLDAP retain];
    [ldap release];
    ldap=newLDAP;
}
#pragma mark Memory Methods
-(void)dealloc{
    [entries release];
    [ldap release];
    [outlineViewCache release];
    [super dealloc];
}



@end
