#import "FavoritesDataSource.h"

@implementation FavoritesDataSource
#pragma mark Setup Methods
- (id)init
{
    [super init];
    
    NSMutableDictionary *defaultPrefs = [NSMutableDictionary dictionary];
    NSMutableArray *empty = [NSMutableArray arrayWithCapacity:0];
   [defaultPrefs setObject:empty forKey:@"Favorites"];
    
    prefs = [[NSUserDefaults standardUserDefaults] retain];
    [prefs registerDefaults:defaultPrefs];
    return self;
}
#pragma mark Table View Methods
- (void)tableViewSelectionDidChange:(NSNotification *)aNotification{

    if ([favoritesTableView selectedRow]!=-1) {
	NSDictionary *dict=[[prefs objectForKey:@"Favorites"] objectAtIndex:[favoritesTableView selectedRow]];

	    
	    
	[mainDocument setInterfaceUseSSL:[[dict objectForKey:@"useSSL"] intValue]
				authType:[[dict objectForKey:@"authType"] intValue]
				    host:[dict objectForKey:@"host"]
				    port:[[dict objectForKey:@"port"] intValue]
				  baseDN:[dict objectForKey:@"baseDN"]
				addToKeychain:[[dict objectForKey:@"addToKeychain"] intValue]
				username:[dict objectForKey:@"userName"]];
    }
}
- (BOOL)tableView:(NSTableView *)aTableView shouldEditTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex{
    return NO;
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView{
   return  [[prefs objectForKey:@"Favorites"] count];
}
- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex{
    NSDictionary *dict=[[prefs objectForKey:@"Favorites"] objectAtIndex:rowIndex];
    NSString *retString=[NSString stringWithFormat:@"%@%@%@:%@/%@", 
	([[dict objectForKey:@"useSSL"] boolValue] == YES ? @"ldaps://" : @"ldap://"),
	(([[dict objectForKey:@"authType"] intValue] == 0) ? @"" : [NSString stringWithFormat:@"%@@", [dict objectForKey:@"userName"]]),
	[dict objectForKey:@"host"], 
	[[NSNumber numberWithInt:[[dict objectForKey:@"port"] intValue]] stringValue], 
	[dict objectForKey:@"baseDN"]];

   [aTableView sizeToFit];
    
    return retString;
}
#pragma mark Favorite Methods
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Favorite Menu Methods /////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)newAddToFavoritesItem:(NSDictionary *)menuItemData
{
    int x;
    
    // Make sure the item we are about to add does not already exist in the favorites menu. If so, return without adding.
    if([favoritesMenu numberOfItems] != 3) {
	for(x = 3; x < [favoritesMenu numberOfItems]; x++) {
	    if([[[favoritesMenu itemAtIndex:x] representedObject] isEqual:menuItemData]) {
		return;
	    }
	}
    }
    
    //	// Make sure the item we are about to add does not already exist in the add to favorites menu. If so, return without adding.
    //	if([favoritesAddMenu numberOfItems]) {	
    //		for(x = 0; x < [favoritesAddMenu numberOfItems]; x++) {
    //			if([[[favoritesAddMenu itemAtIndex:x] representedObject] isEqual:menuItemData]) {
    //				return;
    //			}
    //		}
    //	}
    
    // Ok, time to add an item. Make sure the add to favorites menu doesn't have and item titled "No Items To Add"
    // if it does, remove that item
    if([[[favoritesAddMenu itemAtIndex:0] title] isEqual:@"No Items To Add"]) [favoritesAddMenu removeItemAtIndex:0];
    
    menuItem = [self createMenuItem:menuItemData];
    [menuItem setAction:@selector(addToFavorites:)];
    
    [favoritesAddMenu addItem:menuItem];
}
- (void)removeAddToFavoritesItem:(NSMenuItem *)m
{
 /*
    if([favoritesAddMenu indexOfItem:m] != -1) [favoritesAddMenu removeItem:m];
    if([favoritesAddMenu numberOfItems] == 0) {
	NSMenuItem *temp = [[[NSMenuItem alloc] init] autorelease];
	[temp setTitle:@"No Items To Add"];
	[temp setEnabled:NO];		
	[favoritesAddMenu addItem:temp];
    }
 */
}
- (void)updateRemoveFromFavoritesItems
{
 /*   NSArray *favoriteList = [favoritesMenu itemArray];
    int x;
    
    while([favoritesRemoveMenu numberOfItems]) [favoritesRemoveMenu removeItemAtIndex:0];	
    
    if([favoriteList count] < 4) {
	NSMenuItem *temp = [[[NSMenuItem alloc] init] autorelease];
	[temp setTitle:@"No Items To Remove"];
	[temp setEnabled:NO];		
	[favoritesRemoveMenu addItem:temp];
	return;
    }
    
    for(x = 3; x < [favoriteList count]; x++) {
	NSMenuItem *temp = [[[NSMenuItem alloc] init] autorelease];
	[temp setTitle:[[favoriteList objectAtIndex:x] title]];;
	[temp setRepresentedObject:[favoriteList objectAtIndex:x]];
	[temp setImage:[[favoriteList objectAtIndex:x] image]];
	[temp setEnabled:YES];
	[temp setAction:@selector(removeFavorite:)];
	[favoritesRemoveMenu addItem:temp];
    }
    */
}

- (IBAction)addToFavorites:(id)sender
{
   // [self removeAddToFavoritesItem:sender];
    //[favoritesMenu addItem:sender];
  //  [self updateRemoveFromFavoritesItems];
 //   [self updateFavoritesPrefs];
    //NSLog([mainDocument prefDataFromInterface]);
    NSMutableArray *ma=[NSMutableArray arrayWithArray:[prefs objectForKey:@"Favorites"]];
    [ma insertObject:[mainDocument prefDataFromInterface] atIndex:0];
    [prefs setObject:ma forKey:@"Favorites"];
    [prefs synchronize];
    
    [favoritesTableView reloadData];
    
}
- (IBAction)removeFavorite:(id)sender
{
    // Remove the sender's represented object from the favoritesMenu. Then update the favoritesRemoveMenu menu.
   /* [favoritesMenu removeItem:[sender representedObject]];
    [self updateRemoveFromFavoritesItems];	
    // Fix all the key equivalents for the favorites
    [self setFavoritesKeyEquivalents];
    [self updateFavoritesPrefs];
    */
    
    NSMutableArray *ma=[NSMutableArray arrayWithArray:[prefs objectForKey:@"Favorites"]];
    [ma removeObjectAtIndex:[favoritesTableView selectedRow]];
    [prefs setObject:ma forKey:@"Favorites"];
    [prefs synchronize];
    [favoritesTableView reloadData];
}

- (IBAction)openFavorite:(id)sender
{
    //[cwc makeConnectionFromFavorite:[sender representedObject]];
}

- (NSMenuItem *)createMenuItem:(NSDictionary *)menuItemData
{
    // Create a new menu item, and autorelease it since it will be retained by the menu. Set it up all pretty.
    NSMenuItem *newMenuItem = [[[NSMenuItem alloc] init] autorelease];
    [newMenuItem setTitle:[NSString stringWithFormat:@"%@%@%@:%@/%@", 
	([[menuItemData objectForKey:@"useSSL"] boolValue] == YES ? @"ldaps://" : @"ldap://"),
	(([[menuItemData objectForKey:@"authType"] intValue] == 0) ? @"" : [NSString stringWithFormat:@"%@@", [menuItemData objectForKey:@"userName"]]),
	[menuItemData objectForKey:@"host"], 
	[[NSNumber numberWithInt:[[menuItemData objectForKey:@"port"] intValue]] stringValue], 
	[menuItemData objectForKey:@"baseDN"]]];
    [newMenuItem setRepresentedObject:menuItemData];
    // Just playing with images.. We can make them whatever we want.
    //	if([[menuItemData objectForKey:@"useSSL"] boolValue] == YES)
    //		[menuItem setImage:[NSImage imageNamed:@"SmallLock.tif"]];
    //	else
    [newMenuItem setImage:[NSImage imageNamed:@"LittleDatabase.tiff"]];
    [newMenuItem setEnabled:YES];
    return newMenuItem;
}

- (void)setFavoritesKeyEquivalents
{
    int x;
    if([favoritesMenu numberOfItems] < 4) return;   // are there any favorites?  if not, return
    for(x=1; x < ([favoritesMenu numberOfItems]) - 2; x++) {
	if(x == 10) {
	    [[favoritesMenu itemAtIndex:x+2] setKeyEquivalent:@"0"];
	    [[favoritesMenu itemAtIndex:x+2] setKeyEquivalentModifierMask:NSCommandKeyMask];
	    return;
	}
	[[favoritesMenu itemAtIndex:x+2] setKeyEquivalent:[[NSNumber numberWithInt:x] stringValue]];
	[[favoritesMenu itemAtIndex:x+2] setKeyEquivalentModifierMask:NSCommandKeyMask];
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Prefs
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)updateFavoritesPrefs
{
    int x;
    NSMutableArray *old = [NSMutableArray arrayWithArray:[favoritesMenu itemArray]];
    NSMutableArray *new = [NSMutableArray arrayWithCapacity:0];
    
    [old removeObjectAtIndex:0];
    [old removeObjectAtIndex:0];
    [old removeObjectAtIndex:0];
    
    for(x = 0; x < [old count]; x++) [new addObject:[[old objectAtIndex:x] representedObject]];
    
    [prefs setObject:new forKey:@"Favorites"];
}




@end
