//
//  LDAPQuery.h
//  wormbook
//
//  Created by Timothy Perfitt on Sun Feb 29 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
//#include "portable.h"



#include <ldap.h>
#include "lutil.h"
#include "lutil_ldap.h"

#define AUTH_ANONYMOUS 0
#define AUTH_SIMPLE 1
#define AUTH_MD5 2
#define TIMELIMIT 10

@interface LDAPQuery : NSObject {
    
    NSString *hostURL,*baseDN,*bindUsername,*bindPassword,*saslUsername,*lastError;
    LDAP *ld;
    BOOL bound,useSSL;
    int authType,port;
    NSTimer *bindTimer,*searchTimer;
    NSMutableDictionary *searchTimers;
    
}

-(void)cancelBind;
-(LDAPQuery *)initWithHostURL:(NSString *)hurl port:(int)vPort authType:(int)at bindUsername:(NSString *)bun bindPassword:(NSString *)bpw dn:(NSString *)newDN saslUsername:(NSString *)sun overSSL:(BOOL)ussl;
  //-(NSArray *)getAttributes:(NSString *)attributeName;
-(BOOL)searchWithFilter:(NSString *)filter forAttributes:(NSArray *)ldapAttributeNames scope:(int)scope searchDN:(NSString *)searchDN target:(id)target selector:(SEL)aSelector;
-(BOOL)addEntry:(NSString *)dn withAttributes:(NSDictionary *)person;
-(BOOL)deleteEntry:(NSString *)dn;
-(BOOL)modifyEntry:(NSString *)dn withAttributes:(NSDictionary *)person;
-(BOOL)rename:(NSString *)dn toNewDN:(NSString *)newDN;
-(void)setHostURL:(NSString *)val;
-(void)setBaseDN:(NSString *)val;
-(void)setBindUsername:(NSString *)val;
-(void)setBindPassword:(NSString *)val;
-(void)setSASLUsername:(NSString *)val;
-(BOOL)asyncBindWithSender:(id)sender completedSelector:(SEL)aSelector;
-(BOOL)bound;
-(void)setLastError:(NSString *)val;
-(NSString *)lastError;
-(BOOL)isPrintable:(char *)val;
-(void)simpleBind;
-(BOOL)unbind;
-(void)cancelSearchWithMsgID:(int)msgid;
@end
