//
//  MyDocument.h
//  LDAPManager
//
//  Created by Timothy Perfitt on Fri Apr 16 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import "LDAPQuery.h"
#import "DataSource.h"
#import "KeychainAccess.h"

@interface MyDocument : NSDocument
{
    IBOutlet id attributeOutlineView;
    NSString *baseDN,*host,*password,*userName;
    int port,authType;
    BOOL useSSL, addToKeychain;
    IBOutlet id entryBrowserView;
    IBOutlet id browserWindow;
    IBOutlet id mainWindow;
    IBOutlet id spinner;
    IBOutlet id cancelButton;
    IBOutlet id connectWindow;
    IBOutlet id busyGear;
    BOOL dirty,isConnecting;;
    IBOutlet id hostTextField;
    IBOutlet id baseDNTextField;
    IBOutlet id sslCheckBox;
    IBOutlet id customPortCheckBox;
    IBOutlet id portTextField;
    IBOutlet id useAuthenticationCheckBox;
    IBOutlet id authPopUpButton;
    IBOutlet id userNameTextfield;
    IBOutlet id passwordTextfield;
    IBOutlet id keychainCheckBox;
    IBOutlet id usernameDesc;
    IBOutlet id passwordDesc;
    IBOutlet id typeDesc;
    IBOutlet id connectButton;
    IBOutlet id fetchButton;
    
    NSMutableDictionary *toolbarItems;
    NSMutableArray *runningSearches;
    LDAPQuery *ldap;
}
-(BOOL)commit;
- (BOOL)connect;
- (IBAction)deleteAttribute:(id)sender;
- (IBAction)deleteEntry:(id)sender;
- (IBAction)insertAttribute:(id)sender;
- (IBAction)new:(id)sender;
- (IBAction)revert:(id)sender;
- (IBAction)commit:(id)sender;
- (IBAction)refresh:(id)sender;
- (IBAction)connectionWindow:(id)sender;

- (IBAction)refreshAttributes:(id)sender;
-(void)selectionShouldChange:(NSNotification *)val;
-(void)selectionChangedSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (IBAction)duplicateEntry:(id)sender;
-addToolbarItemToDictionary:(NSMutableDictionary *)dict label:(NSString *)label paletteLabel:(NSString *)pl target:(id)target action:(SEL)action toolTip:(NSString *)toolTip identifier:(NSString *)identifier image:(NSImage *)image;
-(void)setBaseDN:(NSString *)val;
-(void)setHost:(NSString *)val;
-(void)setPassword:(NSString *)val;

-(void)setUserName:(NSString *)val;
-(void)connectionComplete:(id)sender;
//- (void)windowDidResize:(NSNotification *)aNotification;
-(IBAction)cancelConnecting:(id)sender;

- (IBAction)fetchDNButton:(id)sender;
- (IBAction)encrypt:(id)sender;
- (IBAction)customPort:(id)sender;
- (IBAction)useAuthentication:(id)sender;
- (IBAction)authMethodChanged:(id)sender;
- (IBAction)connect:(id)sender;
- (void)checkKeychain;
-(void)setInterfaceUseSSL:(BOOL)ssl authType:(int)at host:(NSString *)thost port:(int)tport baseDN:(NSString *)dn addToKeychain:(BOOL)keychain username:(NSString *)username;
-(NSDictionary *)prefDataFromInterface;
-(id)ldap;
@end
