/* MyDocumentController */

#import <Cocoa/Cocoa.h>
#import "MyDocument.h"
#import "ConnectWindowController.h"
@interface MyDocumentController : NSDocumentController
{
    ConnectWindowController *cwc;
	NSMenuItem *menuItem;
    IBOutlet NSMenu *favoritesMenu;
    IBOutlet NSMenu *favoritesAddMenu;
    IBOutlet NSMenu *favoritesRemoveMenu;
	NSUserDefaults *prefs;
}

- (ConnectWindowController *)connectWindow;
- (BOOL)createNewDocumentWithCustomData:(NSDictionary *)data;

// Favorite Menu Methods
- (void)newAddToFavoritesItem:(NSDictionary *)menuItemData;
- (void)removeAddToFavoritesItem:(NSMenuItem *)m;
- (void)updateRemoveFromFavoritesItems;
- (IBAction)addToFavorites:(id)sender;
- (IBAction)removeFavorite:(id)sender;
- (IBAction)openFavorite:(id)sender;
- (NSMenuItem *)createMenuItem:(NSDictionary *)menuItemData;
- (void)setFavoritesKeyEquivalents;

// Prefs
- (void)updateFavoritesPrefs;

@end
