#import "TranscriptDataSource.h"

@implementation TranscriptDataSource

-(void)awakeFromNib{
    runningSearches=[[NSMutableArray alloc] init];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchRunning:) name:@"SearchStarted" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchCompleted:) name:@"SearchCompleted" object:nil];
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex{
    if ([[aTableColumn identifier] isEqualToString:@"0"]) return [NSString stringWithFormat:[[runningSearches objectAtIndex:rowIndex] objectForKey:@"description"]];
    else return nil;
    
}
- (int)numberOfRowsInTableView:(NSTableView *)aTableView{
    return [runningSearches count];
}
#pragma mark Spinner
- (void)searchRunning:(NSNotification *)aNotification{
    if ([aNotification object]==[myDoc ldap] ) {
	NSNumber *msgid=[[aNotification userInfo] objectForKey:@"msgid"];
	NSString *description=[[aNotification userInfo] objectForKey:@"description"];
	NSDictionary *dict=[NSDictionary dictionaryWithObjectsAndKeys:msgid,@"msgid",description,@"description",nil];
	[runningSearches addObject:dict];
	[tableView reloadData];
    }
    
}
- (void)searchCompleted:(NSNotification *)aNotification{
    int i;
     if ([aNotification object]==[myDoc ldap] ) {
	 for (i=0;i<[runningSearches count];i++){
	    NSNumber *msgid=[[aNotification userInfo] objectForKey:@"msgid"];
	     if ([[[runningSearches objectAtIndex:i] objectForKey:@"msgid"] intValue]==[msgid intValue]) {
		    [runningSearches removeObjectAtIndex:i];
		}
	 }
	[tableView reloadData];
     }
}

-(IBAction)cancelSearch:(id)sender{
    int msgid=[[[runningSearches objectAtIndex:[sender selectedRow]] objectForKey:@"msgid"] intValue];
    [[myDoc ldap] cancelSearchWithMsgID:msgid];
}
//cancelSearchWithMsgID

#pragma mark dealloc

-(void)dealloc{
    [runningSearches release];
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [super dealloc];
}
@end
